Sync Task

## Sync

Since Ant 1.6

### Description

Synchronize a target directory from the files defined in one or more Resource Collections.

Any file in the target directory that has not been matched by at least one of the nested resource collections gets removed. I.e. if you exclude a file in your sources and a file of that name is present in the target dir, it will get removed from the target.

### Parameters

Attribute | Description | Required
todir | the target directory to sync with the resource collections | Yes
overwrite | Overwrite existing files even if the destination files are newer. | No; defaults to false.
includeEmptyDirs | Copy any empty directories included in the resource collection(s). Note this attribute also controls the behavior for any nested <preserveintarget> element. If this attribute is false (the default) empty directories that only exist in the target directory will be removed even if they are matched by the patterns of <preserveintarget>. This can be overridden by <preserveintarget>'s preserveEmptyDirs attribute. | No; defaults to false.
failonerror | If is set to false, log a warning message, but do not stop the build, when one of the nested filesets points to a directory that doesn't exist. | No; defaults to true.
verbose | Log the files that are being copied. | No; defaults to false.
granularity | The number of milliseconds leeway to give before deciding a file is out of date. This is needed because not every file system supports tracking the last modified time to the millisecond level. Default is 0 milliseconds, or 2 seconds on DOS systems. This can also be useful if source and target files live on separate machines with clocks being out of sync. since Ant 1.6.2. | No.

### Parameters specified as nested elements

#### fileset or any other resource collection

Resource Collections are used to select groups of files to copy. To use a resource collection, the `todir` attribute must be set.

Prior to Ant 1.7 only `<fileset>` has been supported as a nested element.

#### preserveInTarget

Since Ant 1.7.0

Specifies files or directories that should be kept in the target directory even if they are not present in one of the source directories.

This nested element is like a FileSet except that it doesn't support the dir attribute and the usedefaultexcludes attribute defaults to false.

##### Additional Parameters

Attribute | Description | Required
preserveEmptyDirs | Overrules the includeEmptydirs setting for directories matched by this element. If you want to preserve empty directories that are not in your source directory you can either set the task's includeemptydirs attribute or this one. If the two attribute values conflict, this attribute "wins". | No, defaults to the value of the task's includeemptydirs attribute

### Examples

>     <sync todir="site">
>       <fileset dir="generated-site"/>
>     </sync>

overwrites all files in site with newer files from generated-site, deletes files from site that are not present in generated-site.

>     <sync todir="site">
>       <fileset dir="generated-site"/>
>       <preserveintarget>
>         <include name="**/CVS/**"/>
>       </preserveintarget>
>     </sync>

overwrites all files in site with newer files from generated-site, deletes files from site that are not present in generated-site but keeps all files in any CVS sub-directory.